#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <ctype.h>
#include <misc.h>

int
daemonize(void)
{
    return daemon(0, 0);
}

// Swap the values of a and b
void
swapints(int *a, int *b)
{
    int             c;

    c = *a;
    *a = *b;
    *b = c;
}

// Strips off spaces and tabs from beginning and end of strings
void
strcrop(char *str)
{
    char           *newstr;
    int             i,
                    j;

    newstr = malloc(strlen(str) + 1);

    // Skip spaces and tabs at beginning of str
    i = 0;
    while ((str[i] == ' ' || str[i] == '\t' || str[i] == '\n') && i < strlen(str))
	i++;

    // Copy rest of the string in 'newstr', including terminating 0
    for (j = 0; i < (strlen(str) + 1); i++, j++) {
	newstr[j] = str[i];
    }

    // Cut off spaces and tabs at end of newstr
    j = strlen(newstr) - 1;
    while ((newstr[j] == ' ' || newstr[j] == '\t' || str[j] == '\n') && j >= 0) {
	newstr[j] = '\0';
	j--;
    }

    // Copy newstr into str
    strcpy(str, newstr);

    free(newstr);
}


// Lowercase string 'str' 
char           *
locase(char *str)
{
    int             i;

    for (i = 0; i < strlen(str); i++) {
	str[i] = (char)(tolower((int)str[i]));
    }

    return str;
}

// Is filename str1 newer than str2?
int
isnewer(char *str1, char *str2)
{
    char            date1[10];
    char            date2[10];
    int             count1,
                    count2;


    // If filenames can't be parsed, return false
    if (sscanf(str1, "%8s-%d.log", date1, &count1) != 2 || sscanf(str2, "%8s-%d.log", date2, &count2) != 2)
	return 0;

    // If the date-part of the filename 1 is bigger than that of filename2 
    // return 1
    if (strcmp(date1, date2) > 0)
	return 1;

    // If the date is the same ..
    if (strcmp(date1, date2) == 0) {
	if (count1 > count2)
	    return 1;

	if ((count1 + 500) < count2)	// Check wrapping
	    return 1;
    }
    // It's older, return false
    return 0;
}
